"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IsAuthenticatedDirective = exports.HasRoleDirective = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _errors = require("./errors");

var _jsonwebtoken = require("jsonwebtoken");

var jwt = _interopRequireWildcard(_jsonwebtoken);

var _graphqlTools = require("graphql-tools");

var _graphql = require("graphql");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HasRoleDirective = exports.HasRoleDirective = function (_SchemaDirectiveVisit) {
  _inherits(HasRoleDirective, _SchemaDirectiveVisit);

  function HasRoleDirective() {
    _classCallCheck(this, HasRoleDirective);

    return _possibleConstructorReturn(this, (HasRoleDirective.__proto__ || Object.getPrototypeOf(HasRoleDirective)).apply(this, arguments));
  }

  _createClass(HasRoleDirective, [{
    key: "visitFieldDefinition",
    value: function visitFieldDefinition(field) {
      field.resolve = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(result, args, context, info) {
          var expectedRoles, token, id_token, decoded, roles;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  expectedRoles = this.args.roles;

                  if (!(!context || !context.headers || !context.headers.authorization)) {
                    _context.next = 3;
                    break;
                  }

                  throw new _errors.AuthorizationError({ message: "No authorization token." });

                case 3:
                  token = context.headers.authorization;
                  _context.prev = 4;
                  id_token = token.replace("Bearer ", "");
                  decoded = jwt.verify(id_token, process.env.JWT_SECRET, {
                    algorithms: ["RS256"]
                  });
                  roles = decoded["https://grandstack.io/roles"];

                  if (!expectedRoles.some(function (role) {
                    return roles.indexOf(role) !== -1;
                  })) {
                    _context.next = 10;
                    break;
                  }

                  return _context.abrupt("return", result[fieldName]);

                case 10:
                  throw new _errors.AuthorizationError({
                    message: "You are not authorized for this resource"
                  });

                case 13:
                  _context.prev = 13;
                  _context.t0 = _context["catch"](4);
                  throw new _errors.AuthorizationError({
                    message: "You are not authorized for this resource"
                  });

                case 16:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this, [[4, 13]]);
        }));

        return function (_x, _x2, _x3, _x4) {
          return _ref.apply(this, arguments);
        };
      }();
    }
  }, {
    key: "visitObject",
    value: function visitObject(obj) {
      var fields = obj.getFields();
      var expectedRoles = this.args.roles;

      Object.keys(fields).forEach(function (fieldName) {
        var field = fields[fieldName];
        field.resolve = function () {
          var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(result, args, context, info) {
            var token, id_token, decoded, roles;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    if (!(!context || !context.headers || !context.headers.authorization)) {
                      _context2.next = 2;
                      break;
                    }

                    throw new _errors.AuthorizationError({ message: "No authorization token" });

                  case 2:
                    token = context.headers.authorization;
                    _context2.prev = 3;
                    id_token = token.replace("Bearer ", "");
                    decoded = jwt.verify(id_token, process.env.JWT_SECRET, {
                      algorithms: ["RS256"]
                    });
                    roles = decoded["https://grandstack.io/roles"];

                    if (!expectedRoles.some(function (role) {
                      return roles.indexOf(role) !== -1;
                    })) {
                      _context2.next = 9;
                      break;
                    }

                    return _context2.abrupt("return", result[fieldName]);

                  case 9:
                    throw new _errors.AuthorizationError({
                      message: "You are not authorized for this resource"
                    });

                  case 12:
                    _context2.prev = 12;
                    _context2.t0 = _context2["catch"](3);
                    throw new _errors.AuthorizationError({ message: "You are not authorized!!" });

                  case 15:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, this, [[3, 12]]);
          }));

          return function (_x5, _x6, _x7, _x8) {
            return _ref2.apply(this, arguments);
          };
        }();
      });
    }
  }], [{
    key: "getDirectiveDeclaration",
    value: function getDirectiveDeclaration(directiveName, schema) {
      return new _graphql.GraphQLDirective({
        name: "hasRole",
        locations: [_graphql.DirectiveLocation.FIELD_DEFINITION, _graphql.DirectiveLocation.OBJECT],
        args: {
          roles: {
            type: new _graphql.GraphQLList(schema.getType("Role")),
            defaultValue: "reader"
          }
        }
      });
    }
  }]);

  return HasRoleDirective;
}(_graphqlTools.SchemaDirectiveVisitor);

var IsAuthenticatedDirective = exports.IsAuthenticatedDirective = function (_SchemaDirectiveVisit2) {
  _inherits(IsAuthenticatedDirective, _SchemaDirectiveVisit2);

  function IsAuthenticatedDirective() {
    _classCallCheck(this, IsAuthenticatedDirective);

    return _possibleConstructorReturn(this, (IsAuthenticatedDirective.__proto__ || Object.getPrototypeOf(IsAuthenticatedDirective)).apply(this, arguments));
  }

  _createClass(IsAuthenticatedDirective, [{
    key: "visitObject",
    value: function visitObject(obj) {
      var fields = obj.getFields();
      Object.keys(fields).forEach(function (fieldName) {
        var field = fields[fieldName];
        field.resolve = function () {
          var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(result, args, context, info) {
            var token, id_token, decoded;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    if (!(!context || !context.headers || !context.headers.authorization)) {
                      _context3.next = 2;
                      break;
                    }

                    throw new _errors.AuthorizationError({ message: "No authorization token." });

                  case 2:
                    token = context.headers.authorization;
                    _context3.prev = 3;
                    id_token = token.replace("Bearer ", "");
                    decoded = jwt.verify(id_token, process.env.JWT_SECRET, {
                      algorithms: ["RS256"]
                    });
                    return _context3.abrupt("return", result[fieldName]);

                  case 9:
                    _context3.prev = 9;
                    _context3.t0 = _context3["catch"](3);
                    throw new _errors.AuthorizationError({ message: "You are not authorized." });

                  case 12:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this, [[3, 9]]);
          }));

          return function (_x9, _x10, _x11, _x12) {
            return _ref3.apply(this, arguments);
          };
        }();
      });
    }
  }, {
    key: "visitFieldDefinition",
    value: function visitFieldDefinition(field) {

      field.resolve = function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(result, args, context, info) {
          var token, id_token, decoded;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  if (!(!context || !context.headers || !context.headers.authorization)) {
                    _context4.next = 2;
                    break;
                  }

                  throw new _errors.AuthorizationError({ message: "No authorization token." });

                case 2:
                  token = context.headers.authorization;
                  _context4.prev = 3;
                  id_token = token.replace("Bearer ", "");
                  decoded = jwt.verify(id_token, process.env.JWT_SECRET, {
                    algorithms: ["RS256"]
                  });
                  return _context4.abrupt("return", result[field.name]);

                case 9:
                  _context4.prev = 9;
                  _context4.t0 = _context4["catch"](3);
                  throw new _errors.AuthorizationError({
                    message: "You are not authorized for this resource."
                  });

                case 12:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this, [[3, 9]]);
        }));

        return function (_x13, _x14, _x15, _x16) {
          return _ref4.apply(this, arguments);
        };
      }();
    }
  }], [{
    key: "getDirectiveDeclaration",
    value: function getDirectiveDeclaration(directiveName, schema) {
      return new _graphql.GraphQLDirective({
        name: "isAuthenticated",
        locations: [_graphql.DirectiveLocation.FIELD_DEFINITION, _graphql.DirectiveLocation.OBJECT]
      });
    }
  }]);

  return IsAuthenticatedDirective;
}(_graphqlTools.SchemaDirectiveVisitor);